Package com.sas.metadata.remote

# Interface SASLicense

All Superinterfaces:
  `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

public interface SASLicense extends PrimaryType
Used to document the setinit information for SAS products.

Attributes of SASLicense are:

- `Expiration`
- `CPUModelName`
- `CPUModelNumber`
- `CPUSerialNumber`
- `LanguageCode`
- `Language`
- `ProductCode`
- `ProductName`

Associations of SASLicense are:

- `LicensedComponent`

## Usage

To create an instance of this SASLicense, use the `factory` create methods.
Example: create a SASLicense with name "SASLicense_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     SASLicense myObject = (SASLicense) factory.createComplexMetadataObject(objectStore, "SASLicense_Object", MetadataObjects.SASLICENSE, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_LICENSEDCOMPONENT_NAME`
  Constant used for the name of the LicensedComponent association.
  `static final String`
  `ATTRIBUTE_CPUMODELNAME_NAME`
  Constant used for the name of the CPUModelName attribute.
  `static final String`
  `ATTRIBUTE_CPUMODELNUMBER_NAME`
  Constant used for the name of the CPUModelNumber attribute.
  `static final String`
  `ATTRIBUTE_CPUSERIALNUMBER_NAME`
  Constant used for the name of the CPUSerialNumber attribute.
  `static final String`
  `ATTRIBUTE_EXPIRATION_NAME`
  Constant used for the name of the Expiration attribute.
  `static final String`
  `ATTRIBUTE_LANGUAGE_NAME`
  Constant used for the name of the Language attribute.
  `static final String`
  `ATTRIBUTE_LANGUAGECODE_NAME`
  Constant used for the name of the LanguageCode attribute.
  `static final String`
  `ATTRIBUTE_PRODUCTCODE_NAME`
  Constant used for the name of the ProductCode attribute.
  `static final String`
  `ATTRIBUTE_PRODUCTNAME_NAME`
  Constant used for the name of the ProductName attribute.

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getCPUModelName()`
  Gets the `String` value of `CPUModelName`
  `int`
  `getCPUModelNameMaxLength()`
  Gets the maximum length of `CPUModelName`
  `int`
  `getCPUModelNameState()`
  Gets the Metadata State of `CPUModelName`
  `String`
  `getCPUModelNumber()`
  Gets the `String` value of `CPUModelNumber`
  `int`
  `getCPUModelNumberMaxLength()`
  Gets the maximum length of `CPUModelNumber`
  `int`
  `getCPUModelNumberState()`
  Gets the Metadata State of `CPUModelNumber`
  `String`
  `getCPUSerialNumber()`
  Gets the `String` value of `CPUSerialNumber`
  `int`
  `getCPUSerialNumberMaxLength()`
  Gets the maximum length of `CPUSerialNumber`
  `int`
  `getCPUSerialNumberState()`
  Gets the Metadata State of `CPUSerialNumber`
  `double`
  `getExpiration()`
  Gets the `double` value of `Expiration`
  `int`
  `getExpirationState()`
  Gets the Metadata State of `Expiration`
  `String`
  `getLanguage()`
  Gets the `String` value of `Language`
  `String`
  `getLanguageCode()`
  Gets the `String` value of `LanguageCode`
  `int`
  `getLanguageCodeMaxLength()`
  Gets the maximum length of `LanguageCode`
  `int`
  `getLanguageCodeState()`
  Gets the Metadata State of `LanguageCode`
  `int`
  `getLanguageMaxLength()`
  Gets the maximum length of `Language`
  `int`
  `getLanguageState()`
  Gets the Metadata State of `Language`
  `DeployedComponent`
  `getLicensedComponent()`
  Gets the `DeployedComponent` for `LicensedComponent`
  `AssociationList`
  `getLicensedComponents()`
  Gets the AssociationList of `LicensedComponents`
  `AssociationList`
  `getLicensedComponents(boolean fGoToServer)`
  Gets the Associationlist of `LicensedComponents`
  `int`
  `getProductCode()`
  Gets the `int` value of `ProductCode`
  `int`
  `getProductCodeState()`
  Gets the Metadata State of `ProductCode`
  `String`
  `getProductName()`
  Gets the `String` value of `ProductName`
  `int`
  `getProductNameMaxLength()`
  Gets the maximum length of `ProductName`
  `int`
  `getProductNameState()`
  Gets the Metadata State of `ProductName`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `LicensedComponent`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setCPUModelName(String inCPUModelName)`
  Sets the `CPUModelName` value and sets the state to MetadataState.LOCAL.
  `void`
  `setCPUModelName(String inCPUModelName, int state)`
  Sets the `CPUModelName` Metadata State.
  `void`
  `setCPUModelNameState(int state)`
  Sets the Metadata State of `CPUModelName`.
  `void`
  `setCPUModelNumber(String inCPUModelNumber)`
  Sets the `CPUModelNumber` value and sets the state to MetadataState.LOCAL.
  `void`
  `setCPUModelNumber(String inCPUModelNumber, int state)`
  Sets the `CPUModelNumber` Metadata State.
  `void`
  `setCPUModelNumberState(int state)`
  Sets the Metadata State of `CPUModelNumber`.
  `void`
  `setCPUSerialNumber(String inCPUSerialNumber)`
  Sets the `CPUSerialNumber` value and sets the state to MetadataState.LOCAL.
  `void`
  `setCPUSerialNumber(String inCPUSerialNumber, int state)`
  Sets the `CPUSerialNumber` Metadata State.
  `void`
  `setCPUSerialNumberState(int state)`
  Sets the Metadata State of `CPUSerialNumber`.
  `void`
  `setExpiration(double inExpiration)`
  Sets the `Expiration` value and sets the state to MetadataState.LOCAL.
  `void`
  `setExpiration(double inExpiration, int state)`
  Sets the `Expiration` Metadata State.
  `void`
  `setExpiration(String inExpiration)`
  Sets the `Expiration` value and sets the state to MetadataState.LOCAL
  `void`
  `setExpiration(String inExpiration, int state)`
  Sets the `Expiration` value and Metadata State.
  `void`
  `setExpirationState(int state)`
  Sets the Metadata State of `Expiration`.
  `void`
  `setLanguage(String inLanguage)`
  Sets the `Language` value and sets the state to MetadataState.LOCAL.
  `void`
  `setLanguage(String inLanguage, int state)`
  Sets the `Language` Metadata State.
  `void`
  `setLanguageCode(String inLanguageCode)`
  Sets the `LanguageCode` value and sets the state to MetadataState.LOCAL.
  `void`
  `setLanguageCode(String inLanguageCode, int state)`
  Sets the `LanguageCode` Metadata State.
  `void`
  `setLanguageCodeState(int state)`
  Sets the Metadata State of `LanguageCode`.
  `void`
  `setLanguageState(int state)`
  Sets the Metadata State of `Language`.
  `void`
  `setLicensedComponent(DeployedComponent inObject)`
  Sets the `LicensedComponents` list 0th element to be `inObject`.
  `void`
  `setLicensedComponents(AssociationList list)`
  Sets the `LicensedComponents` list to be `list`.
  `void`
  `setLicensedComponents(AssociationList list, int state)`
  Sets the `LicensedComponents` list to be `list`.
  `void`
  `setProductCode(int inProductCode)`
  Sets the `ProductCode` value and sets the state to MetadataState.LOCAL.
  `void`
  `setProductCode(int inProductCode, int state)`
  Sets the `ProductCode` Metadata State.
  `void`
  `setProductCode(String inProductCode)`
  Sets the `ProductCode` value and sets the state to MetadataState.LOCAL.
  `void`
  `setProductCode(String inProductCode, int state)`
  Sets the `ProductCode` value and Metadata State.
  `void`
  `setProductCodeState(int state)`
  Sets the Metadata State of `ProductCode`.
  `void`
  `setProductName(String inProductName)`
  Sets the `ProductName` value and sets the state to MetadataState.LOCAL.
  `void`
  `setProductName(String inProductName, int state)`
  Sets the `ProductName` Metadata State.
  `void`
  `setProductNameState(int state)`
  Sets the Metadata State of `ProductName`.

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_EXPIRATION_NAME

    static final String ATTRIBUTE_EXPIRATION_NAME
    Constant used for the name of the Expiration attribute.

    Expiration: The date this SASLicense expires.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_CPUMODELNAME_NAME

    static final String ATTRIBUTE_CPUMODELNAME_NAME
    Constant used for the name of the CPUModelName attribute.

    CPUModelName: CPU Model Name

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_CPUMODELNUMBER_NAME

    static final String ATTRIBUTE_CPUMODELNUMBER_NAME
    Constant used for the name of the CPUModelNumber attribute.

    CPUModelNumber: CPU Model Number

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_CPUSERIALNUMBER_NAME

    static final String ATTRIBUTE_CPUSERIALNUMBER_NAME
    Constant used for the name of the CPUSerialNumber attribute.

    CPUSerialNumber: CPU Serial Number

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_LANGUAGECODE_NAME

    static final String ATTRIBUTE_LANGUAGECODE_NAME
    Constant used for the name of the LanguageCode attribute.

    LanguageCode: Code for the language that is licensed.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_LANGUAGE_NAME

    static final String ATTRIBUTE_LANGUAGE_NAME
    Constant used for the name of the Language attribute.

    Language: The language that is licensed.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_PRODUCTCODE_NAME

    static final String ATTRIBUTE_PRODUCTCODE_NAME
    Constant used for the name of the ProductCode attribute.

    ProductCode: The code for the product being licensed.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_PRODUCTNAME_NAME

    static final String ATTRIBUTE_PRODUCTNAME_NAME
    Constant used for the name of the ProductName attribute.

    ProductName: The name of the product being licensed.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_LICENSEDCOMPONENT_NAME

    static final String ASSOCIATION_LICENSEDCOMPONENT_NAME
    Constant used for the name of the LicensedComponent association.

    LicensedComponent: The component this SASLicense is licensing.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `LicensedComponent`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getExpiration

    double getExpiration() throws RemoteException
    Gets the `double` value of `Expiration`
    Returns:
      The `Expiration`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getExpirationState

    int getExpirationState() throws RemoteException
    Gets the Metadata State of `Expiration`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCPUModelName

    String getCPUModelName() throws RemoteException
    Gets the `String` value of `CPUModelName`
    Returns:
      The `CPUModelName`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCPUModelNameState

    int getCPUModelNameState() throws RemoteException
    Gets the Metadata State of `CPUModelName`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCPUModelNameMaxLength

    int getCPUModelNameMaxLength() throws RemoteException
    Gets the maximum length of `CPUModelName`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCPUModelNumber

    String getCPUModelNumber() throws RemoteException
    Gets the `String` value of `CPUModelNumber`
    Returns:
      The `CPUModelNumber`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCPUModelNumberState

    int getCPUModelNumberState() throws RemoteException
    Gets the Metadata State of `CPUModelNumber`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCPUModelNumberMaxLength

    int getCPUModelNumberMaxLength() throws RemoteException
    Gets the maximum length of `CPUModelNumber`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCPUSerialNumber

    String getCPUSerialNumber() throws RemoteException
    Gets the `String` value of `CPUSerialNumber`
    Returns:
      The `CPUSerialNumber`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCPUSerialNumberState

    int getCPUSerialNumberState() throws RemoteException
    Gets the Metadata State of `CPUSerialNumber`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCPUSerialNumberMaxLength

    int getCPUSerialNumberMaxLength() throws RemoteException
    Gets the maximum length of `CPUSerialNumber`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getLanguageCode

    String getLanguageCode() throws RemoteException
    Gets the `String` value of `LanguageCode`
    Returns:
      The `LanguageCode`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getLanguageCodeState

    int getLanguageCodeState() throws RemoteException
    Gets the Metadata State of `LanguageCode`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getLanguageCodeMaxLength

    int getLanguageCodeMaxLength() throws RemoteException
    Gets the maximum length of `LanguageCode`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getLanguage

    String getLanguage() throws RemoteException
    Gets the `String` value of `Language`
    Returns:
      The `Language`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getLanguageState

    int getLanguageState() throws RemoteException
    Gets the Metadata State of `Language`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getLanguageMaxLength

    int getLanguageMaxLength() throws RemoteException
    Gets the maximum length of `Language`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getProductCode

    int getProductCode() throws RemoteException
    Gets the `int` value of `ProductCode`
    Returns:
      The `ProductCode`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getProductCodeState

    int getProductCodeState() throws RemoteException
    Gets the Metadata State of `ProductCode`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getProductName

    String getProductName() throws RemoteException
    Gets the `String` value of `ProductName`
    Returns:
      The `ProductName`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getProductNameState

    int getProductNameState() throws RemoteException
    Gets the Metadata State of `ProductName`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getProductNameMaxLength

    int getProductNameMaxLength() throws RemoteException
    Gets the maximum length of `ProductName`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getLicensedComponents

    AssociationList getLicensedComponents() throws RemoteException, MdException
    Gets the AssociationList of `LicensedComponents`
    Returns:
      Returns the AssociationList of `LicensedComponents` which can be of type:
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getLicensedComponent

    DeployedComponent getLicensedComponent() throws RemoteException, MdException
    Gets the `DeployedComponent` for `LicensedComponent`
    Returns:
      The `DeployedComponent` ( `null` if not set) of `LicensedComponent`which can be of type:
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getLicensedComponents

    AssociationList getLicensedComponents(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `LicensedComponents`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `LicensedComponents` which can be of type:
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setExpiration

    void setExpiration(double inExpiration) throws RemoteException
    Sets the `Expiration` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inExpiration` - double
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setExpiration

    void setExpiration(double inExpiration, int state) throws RemoteException
    Sets the `Expiration` Metadata State.
    Parameters:
      `inExpiration` - double
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setExpiration

    void setExpiration(String inExpiration) throws RemoteException
    Sets the `Expiration` value and sets the state to MetadataState.LOCAL
    Parameters:
      `inExpiration` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setExpiration

    void setExpiration(String inExpiration, int state) throws RemoteException
    Sets the `Expiration` value and Metadata State.
    Parameters:
      `inExpiration` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setExpirationState

    void setExpirationState(int state) throws RemoteException
    Sets the Metadata State of `Expiration`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCPUModelName

    void setCPUModelName(String inCPUModelName) throws RemoteException
    Sets the `CPUModelName` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inCPUModelName` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCPUModelName

    void setCPUModelName(String inCPUModelName, int state) throws RemoteException
    Sets the `CPUModelName` Metadata State.
    Parameters:
      `inCPUModelName` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCPUModelNameState

    void setCPUModelNameState(int state) throws RemoteException
    Sets the Metadata State of `CPUModelName`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCPUModelNumber

    void setCPUModelNumber(String inCPUModelNumber) throws RemoteException
    Sets the `CPUModelNumber` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inCPUModelNumber` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCPUModelNumber

    void setCPUModelNumber(String inCPUModelNumber, int state) throws RemoteException
    Sets the `CPUModelNumber` Metadata State.
    Parameters:
      `inCPUModelNumber` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCPUModelNumberState

    void setCPUModelNumberState(int state) throws RemoteException
    Sets the Metadata State of `CPUModelNumber`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCPUSerialNumber

    void setCPUSerialNumber(String inCPUSerialNumber) throws RemoteException
    Sets the `CPUSerialNumber` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inCPUSerialNumber` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCPUSerialNumber

    void setCPUSerialNumber(String inCPUSerialNumber, int state) throws RemoteException
    Sets the `CPUSerialNumber` Metadata State.
    Parameters:
      `inCPUSerialNumber` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCPUSerialNumberState

    void setCPUSerialNumberState(int state) throws RemoteException
    Sets the Metadata State of `CPUSerialNumber`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLanguageCode

    void setLanguageCode(String inLanguageCode) throws RemoteException
    Sets the `LanguageCode` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inLanguageCode` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLanguageCode

    void setLanguageCode(String inLanguageCode, int state) throws RemoteException
    Sets the `LanguageCode` Metadata State.
    Parameters:
      `inLanguageCode` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLanguageCodeState

    void setLanguageCodeState(int state) throws RemoteException
    Sets the Metadata State of `LanguageCode`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLanguage

    void setLanguage(String inLanguage) throws RemoteException
    Sets the `Language` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inLanguage` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLanguage

    void setLanguage(String inLanguage, int state) throws RemoteException
    Sets the `Language` Metadata State.
    Parameters:
      `inLanguage` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLanguageState

    void setLanguageState(int state) throws RemoteException
    Sets the Metadata State of `Language`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setProductCode

    void setProductCode(int inProductCode) throws RemoteException
    Sets the `ProductCode` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inProductCode` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setProductCode

    void setProductCode(int inProductCode, int state) throws RemoteException
    Sets the `ProductCode` Metadata State.
    Parameters:
      `inProductCode` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setProductCode

    void setProductCode(String inProductCode) throws RemoteException
    Sets the `ProductCode` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inProductCode` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setProductCode

    void setProductCode(String inProductCode, int state) throws RemoteException
    Sets the `ProductCode` value and Metadata State.
    Parameters:
      `inProductCode` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setProductCodeState

    void setProductCodeState(int state) throws RemoteException
    Sets the Metadata State of `ProductCode`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setProductName

    void setProductName(String inProductName) throws RemoteException
    Sets the `ProductName` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inProductName` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setProductName

    void setProductName(String inProductName, int state) throws RemoteException
    Sets the `ProductName` Metadata State.
    Parameters:
      `inProductName` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setProductNameState

    void setProductNameState(int state) throws RemoteException
    Sets the Metadata State of `ProductName`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLicensedComponents

    void setLicensedComponents(AssociationList list) throws RemoteException
    Sets the `LicensedComponents` list to be `list`. Object of which can be of type:
    DeployedComponent
    ConfiguredComponent
    ServiceComponent
    ServerComponent
    LogicalServer
    ServerContext
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLicensedComponents

    void setLicensedComponents(AssociationList list, int state) throws RemoteException
    Sets the `LicensedComponents` list to be `list`. Object of which can be of type:
    DeployedComponent
    ConfiguredComponent
    ServiceComponent
    ServerComponent
    LogicalServer
    ServerContext
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLicensedComponent

    void setLicensedComponent(DeployedComponent inObject) throws RemoteException
    Sets the `LicensedComponents` list 0th element to be `inObject`.
    Parameters:
      `inObject` - DeployedComponent
    Throws:
      `RemoteException` - If error communicating with remote object.